/*******************************************************************************
 * Copyright (c) 2003 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/cpl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.hyades.models.common.facades.behavioral;

/**
 * 
 * A implementor is something that implements a behavior of a test.  It is the
 * superclass of all test components and external implementors which are 
 * implementations for modeled and unmodeled behaviors respectively.
 * 
 * @author marcelop
 * @author psun
 * @since
 */
public interface IImplementor extends IDeployableComponent
{
	/**
	 * Returns the block that contains the list of actions for a test case.
	 * 
	 * <p>This reference is unidirectional
	 * 
	 * @return IBlock
	 */
	public IBlock getBlock();

}
