/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.eclipse.hyades.models.common.configuration;

import org.eclipse.emf.common.util.EList;

import org.eclipse.hyades.models.common.common.CMNNamedElement;

import org.eclipse.hyades.models.common.testprofile.TPFDeployment;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CFG Artifact</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGArtifact#getDeployableInstances <em>Deployable Instances</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGArtifact#getDeploymentSpec <em>Deployment Spec</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGArtifact#getLocation <em>Location</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGArtifact#getDeployment <em>Deployment</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGArtifact#getInstances <em>Instances</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGArtifact()
 * @model 
 * @generated
 */
public interface CFGArtifact extends CMNNamedElement
{
	/**
	 * Returns the value of the '<em><b>Deployable Instances</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.common.configuration.CFGDeployable}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.configuration.CFGDeployable#getArtifacts <em>Artifacts</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Deployable Instances</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Deployable Instances</em>' reference list.
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGArtifact_DeployableInstances()
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeployable#getArtifacts
	 * @model type="org.eclipse.hyades.models.common.configuration.CFGDeployable" opposite="artifacts"
	 * @generated
	 */
	EList getDeployableInstances();

	/**
	 * Returns the value of the '<em><b>Deployment Spec</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec#getArtifact <em>Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Deployment Spec</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Deployment Spec</em>' reference.
	 * @see #setDeploymentSpec(CFGDeploymentSpec)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGArtifact_DeploymentSpec()
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeploymentSpec#getArtifact
	 * @model opposite="artifact" required="true"
	 * @generated
	 */
	CFGDeploymentSpec getDeploymentSpec();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.CFGArtifact#getDeploymentSpec <em>Deployment Spec</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Deployment Spec</em>' reference.
	 * @see #getDeploymentSpec()
	 * @generated
	 */
	void setDeploymentSpec(CFGDeploymentSpec value);

	/**
	 * Returns the value of the '<em><b>Location</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.configuration.CFGLocation#getArtifacts <em>Artifacts</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Location</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Location</em>' reference.
	 * @see #setLocation(CFGLocation)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGArtifact_Location()
	 * @see org.eclipse.hyades.models.common.configuration.CFGLocation#getArtifacts
	 * @model opposite="artifacts"
	 * @generated
	 */
	CFGLocation getLocation();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.CFGArtifact#getLocation <em>Location</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Location</em>' reference.
	 * @see #getLocation()
	 * @generated
	 */
	void setLocation(CFGLocation value);

	/**
	 * Returns the value of the '<em><b>Deployment</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.testprofile.TPFDeployment#getArtifacts <em>Artifacts</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Deployment</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Deployment</em>' container reference.
	 * @see #setDeployment(TPFDeployment)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGArtifact_Deployment()
	 * @see org.eclipse.hyades.models.common.testprofile.TPFDeployment#getArtifacts
	 * @model opposite="artifacts" required="true"
	 * @generated
	 */
	TPFDeployment getDeployment();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.CFGArtifact#getDeployment <em>Deployment</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Deployment</em>' container reference.
	 * @see #getDeployment()
	 * @generated
	 */
	void setDeployment(TPFDeployment value);

	/**
	 * Returns the value of the '<em><b>Instances</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.common.configuration.CFGInstance}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getArtifact <em>Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Instances</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Instances</em>' reference list.
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGArtifact_Instances()
	 * @see org.eclipse.hyades.models.common.configuration.CFGInstance#getArtifact
	 * @model type="org.eclipse.hyades.models.common.configuration.CFGInstance" opposite="artifact"
	 * @generated
	 */
	EList getInstances();

} // CFGArtifact
