/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.eclipse.hyades.models.common.configuration;

import org.eclipse.hyades.models.common.common.CMNNamedElement;

import org.eclipse.hyades.models.common.interactions.BVRLifeline;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CFG Instance</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getMaxCount <em>Max Count</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getLifeline <em>Lifeline</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getDeployableOwner <em>Deployable Owner</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getArtifact <em>Artifact</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getDeployableType <em>Deployable Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGInstance()
 * @model 
 * @generated
 */
public interface CFGInstance extends CMNNamedElement
{
	/**
	 * Returns the value of the '<em><b>Max Count</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Max Count</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Max Count</em>' attribute.
	 * @see #setMaxCount(int)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGInstance_MaxCount()
	 * @model 
	 * @generated
	 */
	int getMaxCount();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getMaxCount <em>Max Count</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max Count</em>' attribute.
	 * @see #getMaxCount()
	 * @generated
	 */
	void setMaxCount(int value);

	/**
	 * Returns the value of the '<em><b>Lifeline</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.interactions.BVRLifeline#getInstances <em>Instances</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Lifeline</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Lifeline</em>' reference.
	 * @see #setLifeline(BVRLifeline)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGInstance_Lifeline()
	 * @see org.eclipse.hyades.models.common.interactions.BVRLifeline#getInstances
	 * @model opposite="instances"
	 * @generated
	 */
	BVRLifeline getLifeline();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getLifeline <em>Lifeline</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Lifeline</em>' reference.
	 * @see #getLifeline()
	 * @generated
	 */
	void setLifeline(BVRLifeline value);

	/**
	 * Returns the value of the '<em><b>Deployable Owner</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.configuration.CFGDeployable#getInstances <em>Instances</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Deployable Owner</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Deployable Owner</em>' container reference.
	 * @see #setDeployableOwner(CFGDeployable)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGInstance_DeployableOwner()
	 * @see org.eclipse.hyades.models.common.configuration.CFGDeployable#getInstances
	 * @model opposite="instances" required="true"
	 * @generated
	 */
	CFGDeployable getDeployableOwner();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getDeployableOwner <em>Deployable Owner</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Deployable Owner</em>' container reference.
	 * @see #getDeployableOwner()
	 * @generated
	 */
	void setDeployableOwner(CFGDeployable value);

	/**
	 * Returns the value of the '<em><b>Artifact</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.configuration.CFGArtifact#getInstances <em>Instances</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Artifact</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Artifact</em>' reference.
	 * @see #setArtifact(CFGArtifact)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGInstance_Artifact()
	 * @see org.eclipse.hyades.models.common.configuration.CFGArtifact#getInstances
	 * @model opposite="instances" required="true"
	 * @generated
	 */
	CFGArtifact getArtifact();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getArtifact <em>Artifact</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Artifact</em>' reference.
	 * @see #getArtifact()
	 * @generated
	 */
	void setArtifact(CFGArtifact value);

	/**
	 * Returns the value of the '<em><b>Deployable Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Deployable Type</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Deployable Type</em>' reference.
	 * @see #setDeployableType(CFGDeployable)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGInstance_DeployableType()
	 * @model required="true"
	 * @generated
	 */
	CFGDeployable getDeployableType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.CFGInstance#getDeployableType <em>Deployable Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Deployable Type</em>' reference.
	 * @see #getDeployableType()
	 * @generated
	 */
	void setDeployableType(CFGDeployable value);

} // CFGInstance
