/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.eclipse.hyades.models.common.configuration.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.hyades.models.common.common.impl.CMNNamedElementImpl;

import org.eclipse.hyades.models.common.configuration.CFGArtifact;
import org.eclipse.hyades.models.common.configuration.CFGDeployable;
import org.eclipse.hyades.models.common.configuration.CFGInstance;
import org.eclipse.hyades.models.common.configuration.CFGOperation;
import org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage;
import org.eclipse.hyades.models.common.facades.behavioral.IDeployableComponent;
import org.eclipse.hyades.models.common.facades.behavioral.ITest;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>CFG Deployable</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.CFGDeployableImpl#getOperations <em>Operations</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.CFGDeployableImpl#getArtifacts <em>Artifacts</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.CFGDeployableImpl#getInstances <em>Instances</em>}</li>
 * </ul>
 * </p>
 * 
 * @extends IDeployableComponent
 * @generated NOT
 */
public abstract class CFGDeployableImpl extends CMNNamedElementImpl implements CFGDeployable, IDeployableComponent
{
	/**
	 * The cached value of the '{@link #getOperations() <em>Operations</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOperations()
	 * @generated
	 * @ordered
	 */
	protected EList operations = null;

	/**
	 * The cached value of the '{@link #getArtifacts() <em>Artifacts</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getArtifacts()
	 * @generated
	 * @ordered
	 */
	protected EList artifacts = null;

	/**
	 * The cached value of the '{@link #getInstances() <em>Instances</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInstances()
	 * @generated
	 * @ordered
	 */
	protected EList instances = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CFGDeployableImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass()
	{
		return Common_ConfigurationPackage.eINSTANCE.getCFGDeployable();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getOperations()
	{
		if (operations == null)
		{
			operations = new EObjectContainmentWithInverseEList(CFGOperation.class, this, Common_ConfigurationPackage.CFG_DEPLOYABLE__OPERATIONS, Common_ConfigurationPackage.CFG_OPERATION__DEPLOYABLE);
		}
		return operations;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getArtifacts()
	{
		if (artifacts == null)
		{
			artifacts = new EObjectWithInverseResolvingEList.ManyInverse(CFGArtifact.class, this, Common_ConfigurationPackage.CFG_DEPLOYABLE__ARTIFACTS, Common_ConfigurationPackage.CFG_ARTIFACT__DEPLOYABLE_INSTANCES);
		}
		return artifacts;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getInstances()
	{
		if (instances == null)
		{
			instances = new EObjectContainmentWithInverseEList(CFGInstance.class, this, Common_ConfigurationPackage.CFG_DEPLOYABLE__INSTANCES, Common_ConfigurationPackage.CFG_INSTANCE__DEPLOYABLE_OWNER);
		}
		return instances;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs)
	{
		if (featureID >= 0)
		{
			switch (eDerivedStructuralFeatureID(featureID, baseClass))
			{
				case Common_ConfigurationPackage.CFG_DEPLOYABLE__OPERATIONS:
					return ((InternalEList)getOperations()).basicAdd(otherEnd, msgs);
				case Common_ConfigurationPackage.CFG_DEPLOYABLE__ARTIFACTS:
					return ((InternalEList)getArtifacts()).basicAdd(otherEnd, msgs);
				case Common_ConfigurationPackage.CFG_DEPLOYABLE__INSTANCES:
					return ((InternalEList)getInstances()).basicAdd(otherEnd, msgs);
				default:
					return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs)
	{
		if (featureID >= 0)
		{
			switch (eDerivedStructuralFeatureID(featureID, baseClass))
			{
				case Common_ConfigurationPackage.CFG_DEPLOYABLE__OPERATIONS:
					return ((InternalEList)getOperations()).basicRemove(otherEnd, msgs);
				case Common_ConfigurationPackage.CFG_DEPLOYABLE__ARTIFACTS:
					return ((InternalEList)getArtifacts()).basicRemove(otherEnd, msgs);
				case Common_ConfigurationPackage.CFG_DEPLOYABLE__INSTANCES:
					return ((InternalEList)getInstances()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__ID:
				return getId();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__NAME:
				return getName();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__DESCRIPTION:
				return getDescription();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__OPERATIONS:
				return getOperations();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__ARTIFACTS:
				return getArtifacts();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__INSTANCES:
				return getInstances();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__ID:
				setId((String)newValue);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__NAME:
				setName((String)newValue);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__OPERATIONS:
				getOperations().clear();
				getOperations().addAll((Collection)newValue);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__ARTIFACTS:
				getArtifacts().clear();
				getArtifacts().addAll((Collection)newValue);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__INSTANCES:
				getInstances().clear();
				getInstances().addAll((Collection)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__ID:
				setId(ID_EDEFAULT);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__OPERATIONS:
				getOperations().clear();
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__ARTIFACTS:
				getArtifacts().clear();
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__INSTANCES:
				getInstances().clear();
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__OPERATIONS:
				return operations != null && !operations.isEmpty();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__ARTIFACTS:
				return artifacts != null && !artifacts.isEmpty();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__INSTANCES:
				return instances != null && !instances.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.hyades.models.common.facades.behavioral.IDeployableComponent#getLocation()
	 */
	public abstract String getLocation();

	/* (non-Javadoc)
	 * @see org.eclipse.hyades.models.common.facades.behavioral.IDeployableComponent#getOwner()
	 */
	public abstract ITest getOwner();

	/* (non-Javadoc)
	 * @see org.eclipse.hyades.models.common.facades.behavioral.IDeployableComponent#getResource()
	 */
	public abstract String getResource();

	/* (non-Javadoc)
	 * @see org.eclipse.hyades.models.common.facades.behavioral.IDeployableComponent#setLocation(java.lang.String)
	 */
	public abstract void setLocation(String location);
	
	/* (non-Javadoc)
	 * @see org.eclipse.hyades.models.common.facades.behavioral.IDeployableComponent#setResource(java.lang.String)
	 */
	public abstract void setResource(String resource);
	
} //CFGDeployableImpl
