/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.eclipse.hyades.models.common.fragments.util;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import org.eclipse.hyades.models.common.common.CMNNamedElement;

import org.eclipse.hyades.models.common.fragments.*;

import org.eclipse.hyades.models.common.interactions.BVREventOccurrence;
import org.eclipse.hyades.models.common.interactions.BVRInteractionFragment;
import org.eclipse.hyades.models.common.interactions.BVRMessageEnd;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.common.fragments.Common_Behavior_FragmentsPackage
 * @generated
 */
public class Common_Behavior_FragmentsSwitch
{
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static Common_Behavior_FragmentsPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Common_Behavior_FragmentsSwitch()
	{
		if (modelPackage == null)
		{
			modelPackage = Common_Behavior_FragmentsPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public Object doSwitch(EObject theEObject)
	{
		EClass theEClass = theEObject.eClass();
		if (theEClass.eContainer() == modelPackage)
		{
			switch (theEClass.getClassifierID())
			{
				case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE:
				{
					BVRInteractionOccurrence bvrInteractionOccurrence = (BVRInteractionOccurrence)theEObject;
					Object result = caseBVRInteractionOccurrence(bvrInteractionOccurrence);
					if (result == null) result = caseBVRInteractionFragment(bvrInteractionOccurrence);
					if (result == null) result = caseCMNNamedElement(bvrInteractionOccurrence);
					if (result == null) result = defaultCase(theEObject);
					return result;
				}
				case Common_Behavior_FragmentsPackage.BVR_PART_DECOMPOSITION:
				{
					BVRPartDecomposition bvrPartDecomposition = (BVRPartDecomposition)theEObject;
					Object result = caseBVRPartDecomposition(bvrPartDecomposition);
					if (result == null) result = caseBVRInteractionOccurrence(bvrPartDecomposition);
					if (result == null) result = caseBVRInteractionFragment(bvrPartDecomposition);
					if (result == null) result = caseCMNNamedElement(bvrPartDecomposition);
					if (result == null) result = defaultCase(theEObject);
					return result;
				}
				case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND:
				{
					BVRInteractionOperand bvrInteractionOperand = (BVRInteractionOperand)theEObject;
					Object result = caseBVRInteractionOperand(bvrInteractionOperand);
					if (result == null) result = caseBVRInteractionFragment(bvrInteractionOperand);
					if (result == null) result = caseCMNNamedElement(bvrInteractionOperand);
					if (result == null) result = defaultCase(theEObject);
					return result;
				}
				case Common_Behavior_FragmentsPackage.BVR_INTERACTION_CONSTRAINT:
				{
					BVRInteractionConstraint bvrInteractionConstraint = (BVRInteractionConstraint)theEObject;
					Object result = caseBVRInteractionConstraint(bvrInteractionConstraint);
					if (result == null) result = defaultCase(theEObject);
					return result;
				}
				case Common_Behavior_FragmentsPackage.BVR_GATE:
				{
					BVRGate bvrGate = (BVRGate)theEObject;
					Object result = caseBVRGate(bvrGate);
					if (result == null) result = caseBVRMessageEnd(bvrGate);
					if (result == null) result = caseBVREventOccurrence(bvrGate);
					if (result == null) result = caseBVRInteractionFragment(bvrGate);
					if (result == null) result = caseCMNNamedElement(bvrGate);
					if (result == null) result = defaultCase(theEObject);
					return result;
				}
				case Common_Behavior_FragmentsPackage.BVR_COMBINED_FRAGMENT:
				{
					BVRCombinedFragment bvrCombinedFragment = (BVRCombinedFragment)theEObject;
					Object result = caseBVRCombinedFragment(bvrCombinedFragment);
					if (result == null) result = caseBVRInteractionFragment(bvrCombinedFragment);
					if (result == null) result = caseCMNNamedElement(bvrCombinedFragment);
					if (result == null) result = defaultCase(theEObject);
					return result;
				}
				case Common_Behavior_FragmentsPackage.BVR_INTERACTION:
				{
					BVRInteraction bvrInteraction = (BVRInteraction)theEObject;
					Object result = caseBVRInteraction(bvrInteraction);
					if (result == null) result = defaultCase(theEObject);
					return result;
				}
				default: return defaultCase(theEObject);
			}
		}
		return defaultCase(theEObject);
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>BVR Interaction Occurrence</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>BVR Interaction Occurrence</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBVRInteractionOccurrence(BVRInteractionOccurrence object)
	{
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>BVR Part Decomposition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>BVR Part Decomposition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBVRPartDecomposition(BVRPartDecomposition object)
	{
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>BVR Interaction Operand</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>BVR Interaction Operand</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBVRInteractionOperand(BVRInteractionOperand object)
	{
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>BVR Interaction Constraint</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>BVR Interaction Constraint</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBVRInteractionConstraint(BVRInteractionConstraint object)
	{
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>BVR Gate</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>BVR Gate</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBVRGate(BVRGate object)
	{
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>BVR Combined Fragment</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>BVR Combined Fragment</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBVRCombinedFragment(BVRCombinedFragment object)
	{
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>BVR Interaction</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>BVR Interaction</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBVRInteraction(BVRInteraction object)
	{
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>CMN Named Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>CMN Named Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCMNNamedElement(CMNNamedElement object)
	{
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>BVR Interaction Fragment</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>BVR Interaction Fragment</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBVRInteractionFragment(BVRInteractionFragment object)
	{
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>BVR Event Occurrence</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>BVR Event Occurrence</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBVREventOccurrence(BVREventOccurrence object)
	{
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>BVR Message End</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>BVR Message End</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBVRMessageEnd(BVRMessageEnd object)
	{
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public Object defaultCase(EObject object)
	{
		return null;
	}

} //Common_Behavior_FragmentsSwitch
