/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.eclipse.hyades.models.common.interactions;

import org.eclipse.hyades.models.common.testprofile.TPFBehavior;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>BVR Execution Occurrence</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.BVRExecutionOccurrence#getFinishEventOccurrence <em>Finish Event Occurrence</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.BVRExecutionOccurrence#getBeforeEventOccurrence <em>Before Event Occurrence</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.BVRExecutionOccurrence#getOtherBehavior <em>Other Behavior</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsPackage#getBVRExecutionOccurrence()
 * @model 
 * @generated
 */
public interface BVRExecutionOccurrence extends BVRInteractionFragment
{
	/**
	 * Returns the value of the '<em><b>Finish Event Occurrence</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.interactions.BVREventOccurrence#getFinishExecutionOccurrence <em>Finish Execution Occurrence</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Finish Event Occurrence</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Finish Event Occurrence</em>' reference.
	 * @see #setFinishEventOccurrence(BVREventOccurrence)
	 * @see org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsPackage#getBVRExecutionOccurrence_FinishEventOccurrence()
	 * @see org.eclipse.hyades.models.common.interactions.BVREventOccurrence#getFinishExecutionOccurrence
	 * @model opposite="finishExecutionOccurrence" required="true"
	 * @generated
	 */
	BVREventOccurrence getFinishEventOccurrence();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.interactions.BVRExecutionOccurrence#getFinishEventOccurrence <em>Finish Event Occurrence</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Finish Event Occurrence</em>' reference.
	 * @see #getFinishEventOccurrence()
	 * @generated
	 */
	void setFinishEventOccurrence(BVREventOccurrence value);

	/**
	 * Returns the value of the '<em><b>Before Event Occurrence</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.interactions.BVREventOccurrence#getStartExecutionOcurrence <em>Start Execution Ocurrence</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Before Event Occurrence</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Before Event Occurrence</em>' reference.
	 * @see #setBeforeEventOccurrence(BVREventOccurrence)
	 * @see org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsPackage#getBVRExecutionOccurrence_BeforeEventOccurrence()
	 * @see org.eclipse.hyades.models.common.interactions.BVREventOccurrence#getStartExecutionOcurrence
	 * @model opposite="startExecutionOcurrence" required="true"
	 * @generated
	 */
	BVREventOccurrence getBeforeEventOccurrence();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.interactions.BVRExecutionOccurrence#getBeforeEventOccurrence <em>Before Event Occurrence</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Before Event Occurrence</em>' reference.
	 * @see #getBeforeEventOccurrence()
	 * @generated
	 */
	void setBeforeEventOccurrence(BVREventOccurrence value);

	/**
	 * Returns the value of the '<em><b>Other Behavior</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Other Behavior</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Other Behavior</em>' reference.
	 * @see #setOtherBehavior(TPFBehavior)
	 * @see org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsPackage#getBVRExecutionOccurrence_OtherBehavior()
	 * @model required="true"
	 * @generated
	 */
	TPFBehavior getOtherBehavior();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.interactions.BVRExecutionOccurrence#getOtherBehavior <em>Other Behavior</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Other Behavior</em>' reference.
	 * @see #getOtherBehavior()
	 * @generated
	 */
	void setOtherBehavior(TPFBehavior value);

} // BVRExecutionOccurrence
