/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.eclipse.hyades.models.common.testprofile;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>TPF Verdict Reason</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFVerdictReason()
 * @model
 * @generated
 */
public final class TPFVerdictReason extends AbstractEnumerator
{
	/**
	 * The '<em><b>None</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NONE_LITERAL
	 * @model name="none"
	 * @generated
	 * @ordered
	 */
	public static final int NONE = 0;

	/**
	 * The '<em><b>See Description</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SEE_DESCRIPTION_LITERAL
	 * @model name="seeDescription"
	 * @generated
	 * @ordered
	 */
	public static final int SEE_DESCRIPTION = 1;

	/**
	 * The '<em><b>Unknown</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #UNKNOWN_LITERAL
	 * @model name="unknown"
	 * @generated
	 * @ordered
	 */
	public static final int UNKNOWN = 2;

	/**
	 * The '<em><b>Abort</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ABORT_LITERAL
	 * @model name="abort"
	 * @generated
	 * @ordered
	 */
	public static final int ABORT = 3;

	/**
	 * The '<em><b>Did Not Complete</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DID_NOT_COMPLETE_LITERAL
	 * @model name="didNotComplete"
	 * @generated
	 * @ordered
	 */
	public static final int DID_NOT_COMPLETE = 4;

	/**
	 * The '<em><b>None</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>None</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #NONE
	 * @generated
	 * @ordered
	 */
	public static final TPFVerdictReason NONE_LITERAL = new TPFVerdictReason(NONE, "none");

	/**
	 * The '<em><b>See Description</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>See Description</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SEE_DESCRIPTION
	 * @generated
	 * @ordered
	 */
	public static final TPFVerdictReason SEE_DESCRIPTION_LITERAL = new TPFVerdictReason(SEE_DESCRIPTION, "seeDescription");

	/**
	 * The '<em><b>Unknown</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Unknown</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #UNKNOWN
	 * @generated
	 * @ordered
	 */
	public static final TPFVerdictReason UNKNOWN_LITERAL = new TPFVerdictReason(UNKNOWN, "unknown");

	/**
	 * The '<em><b>Abort</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Abort</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ABORT
	 * @generated
	 * @ordered
	 */
	public static final TPFVerdictReason ABORT_LITERAL = new TPFVerdictReason(ABORT, "abort");

	/**
	 * The '<em><b>Did Not Complete</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Did Not Complete</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DID_NOT_COMPLETE
	 * @generated
	 * @ordered
	 */
	public static final TPFVerdictReason DID_NOT_COMPLETE_LITERAL = new TPFVerdictReason(DID_NOT_COMPLETE, "didNotComplete");

	/**
	 * An array of all the '<em><b>TPF Verdict Reason</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final TPFVerdictReason[] VALUES_ARRAY =
		new TPFVerdictReason[]
		{
			NONE_LITERAL,
			SEE_DESCRIPTION_LITERAL,
			UNKNOWN_LITERAL,
			ABORT_LITERAL,
			DID_NOT_COMPLETE_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>TPF Verdict Reason</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>TPF Verdict Reason</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TPFVerdictReason get(String name)
	{
		for (int i = 0; i < VALUES_ARRAY.length; ++i)
		{
			TPFVerdictReason result = VALUES_ARRAY[i];
			if (result.toString().equals(name))
			{
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>TPF Verdict Reason</b></em>' literal with the specified value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TPFVerdictReason get(int value)
	{
		switch (value)
		{
			case NONE: return NONE_LITERAL;
			case SEE_DESCRIPTION: return SEE_DESCRIPTION_LITERAL;
			case UNKNOWN: return UNKNOWN_LITERAL;
			case ABORT: return ABORT_LITERAL;
			case DID_NOT_COMPLETE: return DID_NOT_COMPLETE_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private TPFVerdictReason(int value, String name)
	{
		super(value, name);
	}

} //TPFVerdictReason
